package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 30/12/2018.
 */
public class Employee implements Worker, Transactable{

    BankAccount bankAccount = new BankAccount();
    Double hoursWorked;
    Double hourlyWage;



    public Employee(BankAccount bankAccount, Double hoursWorked, Double hourlyWage) {
        this.bankAccount = bankAccount;
        this.hoursWorked = hoursWorked;
        this.hourlyWage = hourlyWage;
    }

    public Employee() {
        this.hourlyWage = 35.0;
        this.hoursWorked = 0.0;
    }

    public Employee(BankAccount bankAccount) {
        this.bankAccount = bankAccount;
    }

    public BankAccount getBankAccount() {
        return this.bankAccount;
    }

    public void setBankAccount(BankAccount bankAccount) {
        this.bankAccount = bankAccount;

    }

    @Override
    public void increaseHoursWorked(Double numberOfHours) {
        this.hoursWorked+= numberOfHours;

    }

    @Override
    public Double getHoursWorked() {
        return this.hoursWorked;
    }

    @Override
    public Double getHourlyWage() {
        return this.hourlyWage;
    }

    @Override
    public Double getMoneyEarned() {
        return getHourlyWage()*getHoursWorked();
    }

    @Override
    public void deposit(Double amountToIncreaseBy) {
        if(amountToIncreaseBy<0 ){
            throw new IllegalArgumentException();
        }
        this.bankAccount.setBalance(this.bankAccount.balance + amountToIncreaseBy);
    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) throws IllegalArgumentException {
        if(this.bankAccount.balance>=amountToDecreaseBy && amountToDecreaseBy>0){
            this.bankAccount.setBalance(this.bankAccount.balance - amountToDecreaseBy);}
        else throw new IllegalArgumentException();
    }

    @Override
    public Double getBalance() {
        return this.bankAccount.balance;
    }
}
